# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 
"""
$Id: utils.py,v 1.22 2004/04/29 04:48:23 fafhrd91 Exp $
"""

import re
from debug import log_exc

from htmlentitydefs import entitydefs
entitydefs['nbsp'] = ' '
entities_data = [('&%s;'%k, v) for k, v in entitydefs.items() if k != 'amp']
def html_unquote(text):
    for s, r in entities_data:
        try:
            text = text.replace(s, r)
        except:
            pass

    return text.replace('&amp;', '&')

from forum_codes import parser

def forum_parser(self, content, emoticons=1, mimetype='text/plain'):
    return parser.parse_text(content, self, mimetype=mimetype, emoticons=emoticons)


# word-wrap function that preserves line breaks and spaces
# (from http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/148061)
def wrap(s, width=72):
    return reduce(lambda line, word, width=width: '%s%s%s' %
                  (line,
                   ' \n'[(len(line[line.rfind('\n')+1:])
                          + len(word.split('\n',1)[0]
                                ) >= width)],
                   word),
                  s.split(' ')
                  )


def forum_stateChanged(sci):
    try:
        sci.object.notifyStateChanged(sci)
    except:
        log_exc()

# Regexp for snipping the body of a document
HTML_BODY = re.compile('<body[^>]*?>(.*)</body[^>]*?>', re.DOTALL|re.IGNORECASE)

try:
    from mx import Tidy
    mxTidyIsAvailable = 1
except ImportError:
    mxTidyIsAvailable = 0

def forum_html_tidy(self, html):
    """ """
    errors = 0
    output = html
    errordata = ""

    if mxTidyIsAvailable:
        input = html.encode('utf-8')
        
        (errors, warnings, output, errordata) = Tidy.tidy(
            input,
            drop_font_tags=1,
            drop_empty_paras=1,
            indent_spaces=0,
            output_xhtml = 1,
            indent='no',
            word_2000=1,
            wrap=0,
            logical_emphasis = 1,
            char_encoding = 'utf8')

        output = unicode(output, 'utf-8')
        
        if errors:
            output = html

    result = HTML_BODY.search(output)
    if result:
        output = result.group(1).strip()

    return (errors, output, errordata)
